#ifndef BAUD_RATE_CALCS_H
#define BAUD_RATE_CALCS_H

OSCCLOCK equ 10200000
;BAUDRATE equ 9600
OVERHEAD equ 14

INSTPERBIT equ (2*(OSCCLOCK/(4*BAUDRATE))+1)/2
INSTPERHALFBIT equ (2*(OSCCLOCK/(8*BAUDRATE))+1)/2
DELAYBAUD equ (INSTPERBIT-OVERHEAD)/3
NUMBAUDNOPS equ INSTPERBIT-(3*DELAYBAUD)-OVERHEAD
DELAYHALFBAUD equ (INSTPERHALFBIT-OVERHEAD)/3
NUMHALFBAUDNOPS equ INSTPERHALFBIT-(3*DELAYHALFBAUD)-OVERHEAD


#endif
