#ifndef UMUL16X16
#define UMUL16X16

	SEGU data

ACCaHI DS 1
ACCaLO DS 1
ACCbHI DS 1
ACCbLO DS 1
ACCcHI DS 1
ACCcLO DS 1
ACCdHI DS 1
ACCdLO DS 1
	
	
	SEG code
	

; multiplies a 16 bit by 16 bit, giving a 32 bit result
;
; (ACCaHI | ACCaLO) * (ACCbHI | ACCbLO) => (ACCbHI | ACCbLO | ACCcHI | ACCcLO)

UMUL16
    call    setup
    movlw   16   
    movwf   delay_cnt1
    
umul16_loop

	rrf	ACCdHI, F	;rotate d right
	rrf	ACCdLO, F
	btfss   STATUS,C    ;need to add?
	goto    NO_ADD          ; no addition necessary
	movf    ACCaLO,W        ; Addition ( ACCb + ACCa -> ACCb )
	addwf   ACCbLO, F       ;add lsb
	btfsc   STATUS,C    ;add in carry
	incf    ACCbHI, F
	movf    ACCaHI,W 
	addwf   ACCbHI, F	;add msb
NO_ADD  rrf     ACCbHI, F
        rrf     ACCbLO, F
        rrf     ACCcHI, F
        rrf     ACCcLO, F
    decfsz  delay_cnt1,F
    goto    umul16_loop 
    retlw 0
    
    
setup   movlw   16		; for 16 shifts
        movf    ACCbHI,W	   ;move ACCb to ACCd
        movwf   ACCdHI
        movf    ACCbLO,W
        movwf   ACCdLO  
        clrf    ACCbHI  
        clrf    ACCbLO  
        retlw   0       
    

#endif
